/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 1587:
    case 1586:
    case 1585:
    case 1584:
    case 1583:
    case 1582:
    case 1581:
    case 1580:
    case 1579:
    case 1578:
    case 1577:
    case 1576:
    case 1575:
    case 1574:
    case 1573:
    case 1572:
      for (i = XVECLEN (pat, 0) - 1; i >= 0; i--)
          ro[i] = *(ro_loc[i] = &XVECEXP (pat, 0, i));
      break;

    case 524:  /* *extract.subreg.bit */
    case 523:  /* *extract.subreg.bit */
    case 522:  /* *extract.subreg.bit */
    case 521:  /* *extract.subreg.bit */
    case 520:  /* *extract.subreg.bit */
    case 519:  /* *extract.subreg.bit */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 518:  /* *extzv.qihi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 517:  /* *extzv.qihi1 */
    case 516:  /* *extzv */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 512:  /* *iorhi3.ashift8-ext.zerox */
    case 511:  /* *iorhi3.ashift8-ext.zerox */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 510:  /* *iorsiqi.byte1-3 */
    case 509:  /* *xorsiqi.byte1-3 */
    case 508:  /* *iorpsiqi.byte1-3 */
    case 507:  /* *xorpsiqi.byte1-3 */
    case 506:  /* *iorhiqi.byte1-3 */
    case 505:  /* *xorhiqi.byte1-3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 498:  /* *insv.xor-extract */
    case 497:  /* *insv.xor-extract */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 496:  /* *insv.not-bit.7 */
    case 495:  /* *insv.not-bit.0 */
    case 494:  /* *insv.xor1-bit.0 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 493:  /* *insv.not-shiftrt */
    case 492:  /* *insv.not-shiftrt */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 491:  /* *insv.shiftrt */
    case 490:  /* *insv.shiftrt */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 489:  /* *insv.extract */
    case 488:  /* *insv.extract */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 487:  /* *insv.reg */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 1));
      break;

    case 486:  /* *insv.not.io */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 485:  /* *insv.io */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 1));
      break;

    case 483:  /* *movbitqi.0 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 482:  /* *movbitqi.1-6.b */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 481:  /* *movbitqi.1-6.a */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 474:  /* *wdr */
    case 473:  /* *sleep */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 456:  /* *parityqihi2 */
    case 455:  /* *parityhi2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      break;

    case 453:  /* insert_bits */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 452:  /* delay_cycles_4 */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 4), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 5), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[0] = 1;
      break;

    case 451:  /* delay_cycles_3 */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 4), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[0] = 1;
      break;

    case 450:  /* delay_cycles_2 */
    case 449:  /* delay_cycles_1 */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[0] = 1;
      break;

    case 444:  /* epilogue_restores */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 2), 1), 1);
      recog_data.dup_num[0] = 0;
      break;

    case 443:  /* call_prologue_saves */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 2), 1), 1));
      break;

    case 472:  /* *nopv */
    case 442:  /* cli_sei */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[0] = 1;
      break;

    case 441:  /* popqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 440:  /* *sbix_branch_tmp_bit7 */
    case 437:  /* *sbix_branch_bit7 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 439:  /* *sbix_branch_tmp */
    case 438:  /* *sbix_branch_tmp */
    case 436:  /* *sbix_branch */
    case 435:  /* *sbix_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 434:  /* *sbi */
    case 433:  /* *cbi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 431:  /* casesi_hi_sequence */
    case 430:  /* casesi_qi_sequence */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (XVECEXP (pat, 0, 1), 0, 0), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (XVECEXP (pat, 0, 2), 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (XVECEXP (pat, 0, 5), 0, 1), 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 3), 1), 1), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (XVECEXP (pat, 0, 1), 0, 0), 0));
      ro[6] = *(ro_loc[6] = &XEXP (XVECEXP (pat, 0, 4), 1));
      ro[7] = *(ro_loc[7] = &XEXP (XVECEXP (pat, 0, 4), 0));
      ro[8] = *(ro_loc[8] = &XEXP (XVECEXP (XVECEXP (pat, 0, 5), 0, 3), 0));
      ro[9] = *(ro_loc[9] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[10] = *(ro_loc[10] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XVECEXP (pat, 0, 5), 0, 2), 0);
      recog_data.dup_num[0] = 7;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (XVECEXP (pat, 0, 5), 0, 0), 1), 0, 0);
      recog_data.dup_num[1] = 7;
      recog_data.dup_loc[2] = &XEXP (XEXP (XVECEXP (XVECEXP (pat, 0, 2), 0, 0), 1), 0);
      recog_data.dup_num[2] = 5;
      recog_data.dup_loc[3] = &XEXP (XEXP (XVECEXP (XVECEXP (pat, 0, 1), 0, 0), 1), 0);
      recog_data.dup_num[3] = 0;
      break;

    case 429:  /* *tablejump.3byte-pc */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 428:  /* *tablejump */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 2), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 424:  /* call_insn */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 423:  /* jump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 422:  /* difficult_rvbranch */
    case 421:  /* rvbranch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 419:  /* branch_unspec */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      break;

    case 420:  /* difficult_branch */
    case 418:  /* branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 417:  /* *sbrx_and_branchsi */
    case 416:  /* *sbrx_and_branchpsi */
    case 415:  /* *sbrx_and_branchhi */
    case 414:  /* *sbrx_and_branchqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 413:  /* *sbrx_branchdi */
    case 412:  /* *sbrx_branchsi */
    case 411:  /* *sbrx_branchpsi */
    case 410:  /* *sbrx_branchhi */
    case 409:  /* *sbrx_branchqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 397:  /* *cmphi.zero-extend.1 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 396:  /* *cmphi.zero-extend.0 */
    case 395:  /* *cmpqi_sign_extend */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 394:  /* cmpuqq3 */
    case 393:  /* cmpqq3 */
    case 392:  /* cmpqi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 408:  /* *cmpusa */
    case 407:  /* *cmpsa */
    case 406:  /* *cmpusq */
    case 405:  /* *cmpsq */
    case 404:  /* *cmpsi */
    case 403:  /* *cmppsi */
    case 402:  /* cmpuha3 */
    case 401:  /* cmpha3 */
    case 400:  /* cmpuhq3 */
    case 399:  /* cmphq3 */
    case 398:  /* cmphi3 */
    case 391:  /* *reversed_tstusa */
    case 390:  /* *reversed_tstsa */
    case 389:  /* *reversed_tstusq */
    case 388:  /* *reversed_tstsq */
    case 387:  /* *reversed_tstsi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 1428:  /* compare_const_uta2 */
    case 1427:  /* compare_const_ta2 */
    case 1426:  /* compare_const_uda2 */
    case 1425:  /* compare_const_da2 */
    case 1424:  /* compare_const_udq2 */
    case 1423:  /* compare_const_dq2 */
    case 1422:  /* compare_const_di2 */
    case 385:  /* *reversed_tstpsi */
    case 383:  /* *reversed_tsthi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 1412:  /* ussubuta3_const_insn */
    case 1411:  /* usadduta3_const_insn */
    case 1410:  /* ussubuda3_const_insn */
    case 1409:  /* usadduda3_const_insn */
    case 1408:  /* ussubudq3_const_insn */
    case 1407:  /* usaddudq3_const_insn */
    case 1400:  /* sssubta3_const_insn */
    case 1399:  /* ssaddta3_const_insn */
    case 1398:  /* sssubda3_const_insn */
    case 1397:  /* ssaddda3_const_insn */
    case 1396:  /* sssubdq3_const_insn */
    case 1395:  /* ssadddq3_const_insn */
    case 1388:  /* subuta3_const_insn */
    case 1387:  /* subta3_const_insn */
    case 1386:  /* subuda3_const_insn */
    case 1385:  /* subda3_const_insn */
    case 1384:  /* subudq3_const_insn */
    case 1383:  /* subdq3_const_insn */
    case 1382:  /* subdi3_const_insn */
    case 1374:  /* adduta3_const_insn */
    case 1373:  /* addta3_const_insn */
    case 1372:  /* adduda3_const_insn */
    case 1371:  /* addda3_const_insn */
    case 1370:  /* addudq3_const_insn */
    case 1369:  /* adddq3_const_insn */
    case 1368:  /* adddi3_const_insn */
    case 381:  /* *reversed_tstqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 386:  /* *negated_tstsi */
    case 384:  /* *negated_tstpsi */
    case 382:  /* *negated_tsthi */
    case 380:  /* *negated_tstqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 454:  /* *split.flash_segment */
    case 287:  /* *ashlhiqi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 286:  /* *ashluqihiqi3.mem */
    case 285:  /* *ashlsqihiqi3.mem */
    case 284:  /* *ashluqihiqi3 */
    case 283:  /* *ashlsqihiqi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 1306:  /* ssabsqq2 */
    case 1305:  /* ssnegqq2 */
    case 1284:  /* fractunssidi2 */
    case 1283:  /* fractunshidi2 */
    case 1282:  /* fractunsqidi2 */
    case 1281:  /* fractunsutadi2 */
    case 1280:  /* fractunstadi2 */
    case 1279:  /* fractunsudadi2 */
    case 1278:  /* fractunsdadi2 */
    case 1277:  /* fractunsudqdi2 */
    case 1276:  /* fractunsdqdi2 */
    case 1275:  /* fractunsusadi2 */
    case 1274:  /* fractunssadi2 */
    case 1273:  /* fractunsusqdi2 */
    case 1272:  /* fractunssqdi2 */
    case 1271:  /* fractunsuhadi2 */
    case 1270:  /* fractunshadi2 */
    case 1269:  /* fractunsuhqdi2 */
    case 1268:  /* fractunshqdi2 */
    case 1267:  /* fractunsuqqdi2 */
    case 1266:  /* fractunsqqdi2 */
    case 1265:  /* fractunsdisi2 */
    case 1264:  /* fractunshisi2 */
    case 1263:  /* fractunsqisi2 */
    case 1262:  /* fractunsutasi2 */
    case 1261:  /* fractunstasi2 */
    case 1260:  /* fractunsudasi2 */
    case 1259:  /* fractunsdasi2 */
    case 1258:  /* fractunsudqsi2 */
    case 1257:  /* fractunsdqsi2 */
    case 1256:  /* fractunsusasi2 */
    case 1255:  /* fractunssasi2 */
    case 1254:  /* fractunsusqsi2 */
    case 1253:  /* fractunssqsi2 */
    case 1252:  /* fractunsuhasi2 */
    case 1251:  /* fractunshasi2 */
    case 1250:  /* fractunsuhqsi2 */
    case 1249:  /* fractunshqsi2 */
    case 1248:  /* fractunsuqqsi2 */
    case 1247:  /* fractunsqqsi2 */
    case 1246:  /* fractunsdihi2 */
    case 1245:  /* fractunssihi2 */
    case 1244:  /* fractunsqihi2 */
    case 1243:  /* fractunsutahi2 */
    case 1242:  /* fractunstahi2 */
    case 1241:  /* fractunsudahi2 */
    case 1240:  /* fractunsdahi2 */
    case 1239:  /* fractunsudqhi2 */
    case 1238:  /* fractunsdqhi2 */
    case 1237:  /* fractunsusahi2 */
    case 1236:  /* fractunssahi2 */
    case 1235:  /* fractunsusqhi2 */
    case 1234:  /* fractunssqhi2 */
    case 1233:  /* fractunsuhahi2 */
    case 1232:  /* fractunshahi2 */
    case 1231:  /* fractunsuhqhi2 */
    case 1230:  /* fractunshqhi2 */
    case 1229:  /* fractunsuqqhi2 */
    case 1228:  /* fractunsqqhi2 */
    case 1227:  /* fractunsdiqi2 */
    case 1226:  /* fractunssiqi2 */
    case 1225:  /* fractunshiqi2 */
    case 1224:  /* fractunsutaqi2 */
    case 1223:  /* fractunstaqi2 */
    case 1222:  /* fractunsudaqi2 */
    case 1221:  /* fractunsdaqi2 */
    case 1220:  /* fractunsudqqi2 */
    case 1219:  /* fractunsdqqi2 */
    case 1218:  /* fractunsusaqi2 */
    case 1217:  /* fractunssaqi2 */
    case 1216:  /* fractunsusqqi2 */
    case 1215:  /* fractunssqqi2 */
    case 1214:  /* fractunsuhaqi2 */
    case 1213:  /* fractunshaqi2 */
    case 1212:  /* fractunsuhqqi2 */
    case 1211:  /* fractunshqqi2 */
    case 1210:  /* fractunsuqqqi2 */
    case 1209:  /* fractunsqqqi2 */
    case 1208:  /* fractunsdiuta2 */
    case 1207:  /* fractunssiuta2 */
    case 1206:  /* fractunshiuta2 */
    case 1205:  /* fractunsqiuta2 */
    case 1204:  /* fractunstauta2 */
    case 1203:  /* fractunsudauta2 */
    case 1202:  /* fractunsdauta2 */
    case 1201:  /* fractunsudquta2 */
    case 1200:  /* fractunsdquta2 */
    case 1199:  /* fractunsusauta2 */
    case 1198:  /* fractunssauta2 */
    case 1197:  /* fractunsusquta2 */
    case 1196:  /* fractunssquta2 */
    case 1195:  /* fractunsuhauta2 */
    case 1194:  /* fractunshauta2 */
    case 1193:  /* fractunsuhquta2 */
    case 1192:  /* fractunshquta2 */
    case 1191:  /* fractunsuqquta2 */
    case 1190:  /* fractunsqquta2 */
    case 1189:  /* fractunsdita2 */
    case 1188:  /* fractunssita2 */
    case 1187:  /* fractunshita2 */
    case 1186:  /* fractunsqita2 */
    case 1185:  /* fractunsutata2 */
    case 1184:  /* fractunsudata2 */
    case 1183:  /* fractunsdata2 */
    case 1182:  /* fractunsudqta2 */
    case 1181:  /* fractunsdqta2 */
    case 1180:  /* fractunsusata2 */
    case 1179:  /* fractunssata2 */
    case 1178:  /* fractunsusqta2 */
    case 1177:  /* fractunssqta2 */
    case 1176:  /* fractunsuhata2 */
    case 1175:  /* fractunshata2 */
    case 1174:  /* fractunsuhqta2 */
    case 1173:  /* fractunshqta2 */
    case 1172:  /* fractunsuqqta2 */
    case 1171:  /* fractunsqqta2 */
    case 1170:  /* fractunsdiuda2 */
    case 1169:  /* fractunssiuda2 */
    case 1168:  /* fractunshiuda2 */
    case 1167:  /* fractunsqiuda2 */
    case 1166:  /* fractunsutauda2 */
    case 1165:  /* fractunstauda2 */
    case 1164:  /* fractunsdauda2 */
    case 1163:  /* fractunsudquda2 */
    case 1162:  /* fractunsdquda2 */
    case 1161:  /* fractunsusauda2 */
    case 1160:  /* fractunssauda2 */
    case 1159:  /* fractunsusquda2 */
    case 1158:  /* fractunssquda2 */
    case 1157:  /* fractunsuhauda2 */
    case 1156:  /* fractunshauda2 */
    case 1155:  /* fractunsuhquda2 */
    case 1154:  /* fractunshquda2 */
    case 1153:  /* fractunsuqquda2 */
    case 1152:  /* fractunsqquda2 */
    case 1151:  /* fractunsdida2 */
    case 1150:  /* fractunssida2 */
    case 1149:  /* fractunshida2 */
    case 1148:  /* fractunsqida2 */
    case 1147:  /* fractunsutada2 */
    case 1146:  /* fractunstada2 */
    case 1145:  /* fractunsudada2 */
    case 1144:  /* fractunsudqda2 */
    case 1143:  /* fractunsdqda2 */
    case 1142:  /* fractunsusada2 */
    case 1141:  /* fractunssada2 */
    case 1140:  /* fractunsusqda2 */
    case 1139:  /* fractunssqda2 */
    case 1138:  /* fractunsuhada2 */
    case 1137:  /* fractunshada2 */
    case 1136:  /* fractunsuhqda2 */
    case 1135:  /* fractunshqda2 */
    case 1134:  /* fractunsuqqda2 */
    case 1133:  /* fractunsqqda2 */
    case 1132:  /* fractunsdiudq2 */
    case 1131:  /* fractunssiudq2 */
    case 1130:  /* fractunshiudq2 */
    case 1129:  /* fractunsqiudq2 */
    case 1128:  /* fractunsutaudq2 */
    case 1127:  /* fractunstaudq2 */
    case 1126:  /* fractunsudaudq2 */
    case 1125:  /* fractunsdaudq2 */
    case 1124:  /* fractunsdqudq2 */
    case 1123:  /* fractunsusaudq2 */
    case 1122:  /* fractunssaudq2 */
    case 1121:  /* fractunsusqudq2 */
    case 1120:  /* fractunssqudq2 */
    case 1119:  /* fractunsuhaudq2 */
    case 1118:  /* fractunshaudq2 */
    case 1117:  /* fractunsuhqudq2 */
    case 1116:  /* fractunshqudq2 */
    case 1115:  /* fractunsuqqudq2 */
    case 1114:  /* fractunsqqudq2 */
    case 1113:  /* fractunsdidq2 */
    case 1112:  /* fractunssidq2 */
    case 1111:  /* fractunshidq2 */
    case 1110:  /* fractunsqidq2 */
    case 1109:  /* fractunsutadq2 */
    case 1108:  /* fractunstadq2 */
    case 1107:  /* fractunsudadq2 */
    case 1106:  /* fractunsdadq2 */
    case 1105:  /* fractunsudqdq2 */
    case 1104:  /* fractunsusadq2 */
    case 1103:  /* fractunssadq2 */
    case 1102:  /* fractunsusqdq2 */
    case 1101:  /* fractunssqdq2 */
    case 1100:  /* fractunsuhadq2 */
    case 1099:  /* fractunshadq2 */
    case 1098:  /* fractunsuhqdq2 */
    case 1097:  /* fractunshqdq2 */
    case 1096:  /* fractunsuqqdq2 */
    case 1095:  /* fractunsqqdq2 */
    case 1094:  /* fractunsdiusa2 */
    case 1093:  /* fractunssiusa2 */
    case 1092:  /* fractunshiusa2 */
    case 1091:  /* fractunsqiusa2 */
    case 1090:  /* fractunsutausa2 */
    case 1089:  /* fractunstausa2 */
    case 1088:  /* fractunsudausa2 */
    case 1087:  /* fractunsdausa2 */
    case 1086:  /* fractunsudqusa2 */
    case 1085:  /* fractunsdqusa2 */
    case 1084:  /* fractunssausa2 */
    case 1083:  /* fractunsusqusa2 */
    case 1082:  /* fractunssqusa2 */
    case 1081:  /* fractunsuhausa2 */
    case 1080:  /* fractunshausa2 */
    case 1079:  /* fractunsuhqusa2 */
    case 1078:  /* fractunshqusa2 */
    case 1077:  /* fractunsuqqusa2 */
    case 1076:  /* fractunsqqusa2 */
    case 1075:  /* fractunsdisa2 */
    case 1074:  /* fractunssisa2 */
    case 1073:  /* fractunshisa2 */
    case 1072:  /* fractunsqisa2 */
    case 1071:  /* fractunsutasa2 */
    case 1070:  /* fractunstasa2 */
    case 1069:  /* fractunsudasa2 */
    case 1068:  /* fractunsdasa2 */
    case 1067:  /* fractunsudqsa2 */
    case 1066:  /* fractunsdqsa2 */
    case 1065:  /* fractunsusasa2 */
    case 1064:  /* fractunsusqsa2 */
    case 1063:  /* fractunssqsa2 */
    case 1062:  /* fractunsuhasa2 */
    case 1061:  /* fractunshasa2 */
    case 1060:  /* fractunsuhqsa2 */
    case 1059:  /* fractunshqsa2 */
    case 1058:  /* fractunsuqqsa2 */
    case 1057:  /* fractunsqqsa2 */
    case 1056:  /* fractunsdiusq2 */
    case 1055:  /* fractunssiusq2 */
    case 1054:  /* fractunshiusq2 */
    case 1053:  /* fractunsqiusq2 */
    case 1052:  /* fractunsutausq2 */
    case 1051:  /* fractunstausq2 */
    case 1050:  /* fractunsudausq2 */
    case 1049:  /* fractunsdausq2 */
    case 1048:  /* fractunsudqusq2 */
    case 1047:  /* fractunsdqusq2 */
    case 1046:  /* fractunsusausq2 */
    case 1045:  /* fractunssausq2 */
    case 1044:  /* fractunssqusq2 */
    case 1043:  /* fractunsuhausq2 */
    case 1042:  /* fractunshausq2 */
    case 1041:  /* fractunsuhqusq2 */
    case 1040:  /* fractunshqusq2 */
    case 1039:  /* fractunsuqqusq2 */
    case 1038:  /* fractunsqqusq2 */
    case 1037:  /* fractunsdisq2 */
    case 1036:  /* fractunssisq2 */
    case 1035:  /* fractunshisq2 */
    case 1034:  /* fractunsqisq2 */
    case 1033:  /* fractunsutasq2 */
    case 1032:  /* fractunstasq2 */
    case 1031:  /* fractunsudasq2 */
    case 1030:  /* fractunsdasq2 */
    case 1029:  /* fractunsudqsq2 */
    case 1028:  /* fractunsdqsq2 */
    case 1027:  /* fractunsusasq2 */
    case 1026:  /* fractunssasq2 */
    case 1025:  /* fractunsusqsq2 */
    case 1024:  /* fractunsuhasq2 */
    case 1023:  /* fractunshasq2 */
    case 1022:  /* fractunsuhqsq2 */
    case 1021:  /* fractunshqsq2 */
    case 1020:  /* fractunsuqqsq2 */
    case 1019:  /* fractunsqqsq2 */
    case 1018:  /* fractunsdiuha2 */
    case 1017:  /* fractunssiuha2 */
    case 1016:  /* fractunshiuha2 */
    case 1015:  /* fractunsqiuha2 */
    case 1014:  /* fractunsutauha2 */
    case 1013:  /* fractunstauha2 */
    case 1012:  /* fractunsudauha2 */
    case 1011:  /* fractunsdauha2 */
    case 1010:  /* fractunsudquha2 */
    case 1009:  /* fractunsdquha2 */
    case 1008:  /* fractunsusauha2 */
    case 1007:  /* fractunssauha2 */
    case 1006:  /* fractunsusquha2 */
    case 1005:  /* fractunssquha2 */
    case 1004:  /* fractunshauha2 */
    case 1003:  /* fractunsuhquha2 */
    case 1002:  /* fractunshquha2 */
    case 1001:  /* fractunsuqquha2 */
    case 1000:  /* fractunsqquha2 */
    case 999:  /* fractunsdiha2 */
    case 998:  /* fractunssiha2 */
    case 997:  /* fractunshiha2 */
    case 996:  /* fractunsqiha2 */
    case 995:  /* fractunsutaha2 */
    case 994:  /* fractunstaha2 */
    case 993:  /* fractunsudaha2 */
    case 992:  /* fractunsdaha2 */
    case 991:  /* fractunsudqha2 */
    case 990:  /* fractunsdqha2 */
    case 989:  /* fractunsusaha2 */
    case 988:  /* fractunssaha2 */
    case 987:  /* fractunsusqha2 */
    case 986:  /* fractunssqha2 */
    case 985:  /* fractunsuhaha2 */
    case 984:  /* fractunsuhqha2 */
    case 983:  /* fractunshqha2 */
    case 982:  /* fractunsuqqha2 */
    case 981:  /* fractunsqqha2 */
    case 980:  /* fractunsdiuhq2 */
    case 979:  /* fractunssiuhq2 */
    case 978:  /* fractunshiuhq2 */
    case 977:  /* fractunsqiuhq2 */
    case 976:  /* fractunsutauhq2 */
    case 975:  /* fractunstauhq2 */
    case 974:  /* fractunsudauhq2 */
    case 973:  /* fractunsdauhq2 */
    case 972:  /* fractunsudquhq2 */
    case 971:  /* fractunsdquhq2 */
    case 970:  /* fractunsusauhq2 */
    case 969:  /* fractunssauhq2 */
    case 968:  /* fractunsusquhq2 */
    case 967:  /* fractunssquhq2 */
    case 966:  /* fractunsuhauhq2 */
    case 965:  /* fractunshauhq2 */
    case 964:  /* fractunshquhq2 */
    case 963:  /* fractunsuqquhq2 */
    case 962:  /* fractunsqquhq2 */
    case 961:  /* fractunsdihq2 */
    case 960:  /* fractunssihq2 */
    case 959:  /* fractunshihq2 */
    case 958:  /* fractunsqihq2 */
    case 957:  /* fractunsutahq2 */
    case 956:  /* fractunstahq2 */
    case 955:  /* fractunsudahq2 */
    case 954:  /* fractunsdahq2 */
    case 953:  /* fractunsudqhq2 */
    case 952:  /* fractunsdqhq2 */
    case 951:  /* fractunsusahq2 */
    case 950:  /* fractunssahq2 */
    case 949:  /* fractunsusqhq2 */
    case 948:  /* fractunssqhq2 */
    case 947:  /* fractunsuhahq2 */
    case 946:  /* fractunshahq2 */
    case 945:  /* fractunsuhqhq2 */
    case 944:  /* fractunsuqqhq2 */
    case 943:  /* fractunsqqhq2 */
    case 942:  /* fractunsdiuqq2 */
    case 941:  /* fractunssiuqq2 */
    case 940:  /* fractunshiuqq2 */
    case 939:  /* fractunsqiuqq2 */
    case 938:  /* fractunsutauqq2 */
    case 937:  /* fractunstauqq2 */
    case 936:  /* fractunsudauqq2 */
    case 935:  /* fractunsdauqq2 */
    case 934:  /* fractunsudquqq2 */
    case 933:  /* fractunsdquqq2 */
    case 932:  /* fractunsusauqq2 */
    case 931:  /* fractunssauqq2 */
    case 930:  /* fractunsusquqq2 */
    case 929:  /* fractunssquqq2 */
    case 928:  /* fractunsuhauqq2 */
    case 927:  /* fractunshauqq2 */
    case 926:  /* fractunsuhquqq2 */
    case 925:  /* fractunshquqq2 */
    case 924:  /* fractunsqquqq2 */
    case 923:  /* fractunsdiqq2 */
    case 922:  /* fractunssiqq2 */
    case 921:  /* fractunshiqq2 */
    case 920:  /* fractunsqiqq2 */
    case 919:  /* fractunsutaqq2 */
    case 918:  /* fractunstaqq2 */
    case 917:  /* fractunsudaqq2 */
    case 916:  /* fractunsdaqq2 */
    case 915:  /* fractunsudqqq2 */
    case 914:  /* fractunsdqqq2 */
    case 913:  /* fractunsusaqq2 */
    case 912:  /* fractunssaqq2 */
    case 911:  /* fractunsusqqq2 */
    case 910:  /* fractunssqqq2 */
    case 909:  /* fractunsuhaqq2 */
    case 908:  /* fractunshaqq2 */
    case 907:  /* fractunsuhqqq2 */
    case 906:  /* fractunshqqq2 */
    case 905:  /* fractunsuqqqq2 */
    case 904:  /* fractsidi2 */
    case 903:  /* fracthidi2 */
    case 902:  /* fractqidi2 */
    case 901:  /* fractutadi2 */
    case 900:  /* fracttadi2 */
    case 899:  /* fractudadi2 */
    case 898:  /* fractdadi2 */
    case 897:  /* fractudqdi2 */
    case 896:  /* fractdqdi2 */
    case 895:  /* fractusadi2 */
    case 894:  /* fractsadi2 */
    case 893:  /* fractusqdi2 */
    case 892:  /* fractsqdi2 */
    case 891:  /* fractuhadi2 */
    case 890:  /* fracthadi2 */
    case 889:  /* fractuhqdi2 */
    case 888:  /* fracthqdi2 */
    case 887:  /* fractuqqdi2 */
    case 886:  /* fractqqdi2 */
    case 885:  /* fractdisi2 */
    case 884:  /* fracthisi2 */
    case 883:  /* fractqisi2 */
    case 882:  /* fractutasi2 */
    case 881:  /* fracttasi2 */
    case 880:  /* fractudasi2 */
    case 879:  /* fractdasi2 */
    case 878:  /* fractudqsi2 */
    case 877:  /* fractdqsi2 */
    case 876:  /* fractusasi2 */
    case 875:  /* fractsasi2 */
    case 874:  /* fractusqsi2 */
    case 873:  /* fractsqsi2 */
    case 872:  /* fractuhasi2 */
    case 871:  /* fracthasi2 */
    case 870:  /* fractuhqsi2 */
    case 869:  /* fracthqsi2 */
    case 868:  /* fractuqqsi2 */
    case 867:  /* fractqqsi2 */
    case 866:  /* fractdihi2 */
    case 865:  /* fractsihi2 */
    case 864:  /* fractqihi2 */
    case 863:  /* fractutahi2 */
    case 862:  /* fracttahi2 */
    case 861:  /* fractudahi2 */
    case 860:  /* fractdahi2 */
    case 859:  /* fractudqhi2 */
    case 858:  /* fractdqhi2 */
    case 857:  /* fractusahi2 */
    case 856:  /* fractsahi2 */
    case 855:  /* fractusqhi2 */
    case 854:  /* fractsqhi2 */
    case 853:  /* fractuhahi2 */
    case 852:  /* fracthahi2 */
    case 851:  /* fractuhqhi2 */
    case 850:  /* fracthqhi2 */
    case 849:  /* fractuqqhi2 */
    case 848:  /* fractqqhi2 */
    case 847:  /* fractdiqi2 */
    case 846:  /* fractsiqi2 */
    case 845:  /* fracthiqi2 */
    case 844:  /* fractutaqi2 */
    case 843:  /* fracttaqi2 */
    case 842:  /* fractudaqi2 */
    case 841:  /* fractdaqi2 */
    case 840:  /* fractudqqi2 */
    case 839:  /* fractdqqi2 */
    case 838:  /* fractusaqi2 */
    case 837:  /* fractsaqi2 */
    case 836:  /* fractusqqi2 */
    case 835:  /* fractsqqi2 */
    case 834:  /* fractuhaqi2 */
    case 833:  /* fracthaqi2 */
    case 832:  /* fractuhqqi2 */
    case 831:  /* fracthqqi2 */
    case 830:  /* fractuqqqi2 */
    case 829:  /* fractqqqi2 */
    case 828:  /* fractdiuta2 */
    case 827:  /* fractsiuta2 */
    case 826:  /* fracthiuta2 */
    case 825:  /* fractqiuta2 */
    case 824:  /* fracttauta2 */
    case 823:  /* fractudauta2 */
    case 822:  /* fractdauta2 */
    case 821:  /* fractudquta2 */
    case 820:  /* fractdquta2 */
    case 819:  /* fractusauta2 */
    case 818:  /* fractsauta2 */
    case 817:  /* fractusquta2 */
    case 816:  /* fractsquta2 */
    case 815:  /* fractuhauta2 */
    case 814:  /* fracthauta2 */
    case 813:  /* fractuhquta2 */
    case 812:  /* fracthquta2 */
    case 811:  /* fractuqquta2 */
    case 810:  /* fractqquta2 */
    case 809:  /* fractdita2 */
    case 808:  /* fractsita2 */
    case 807:  /* fracthita2 */
    case 806:  /* fractqita2 */
    case 805:  /* fractutata2 */
    case 804:  /* fractudata2 */
    case 803:  /* fractdata2 */
    case 802:  /* fractudqta2 */
    case 801:  /* fractdqta2 */
    case 800:  /* fractusata2 */
    case 799:  /* fractsata2 */
    case 798:  /* fractusqta2 */
    case 797:  /* fractsqta2 */
    case 796:  /* fractuhata2 */
    case 795:  /* fracthata2 */
    case 794:  /* fractuhqta2 */
    case 793:  /* fracthqta2 */
    case 792:  /* fractuqqta2 */
    case 791:  /* fractqqta2 */
    case 790:  /* fractdiuda2 */
    case 789:  /* fractsiuda2 */
    case 788:  /* fracthiuda2 */
    case 787:  /* fractqiuda2 */
    case 786:  /* fractutauda2 */
    case 785:  /* fracttauda2 */
    case 784:  /* fractdauda2 */
    case 783:  /* fractudquda2 */
    case 782:  /* fractdquda2 */
    case 781:  /* fractusauda2 */
    case 780:  /* fractsauda2 */
    case 779:  /* fractusquda2 */
    case 778:  /* fractsquda2 */
    case 777:  /* fractuhauda2 */
    case 776:  /* fracthauda2 */
    case 775:  /* fractuhquda2 */
    case 774:  /* fracthquda2 */
    case 773:  /* fractuqquda2 */
    case 772:  /* fractqquda2 */
    case 771:  /* fractdida2 */
    case 770:  /* fractsida2 */
    case 769:  /* fracthida2 */
    case 768:  /* fractqida2 */
    case 767:  /* fractutada2 */
    case 766:  /* fracttada2 */
    case 765:  /* fractudada2 */
    case 764:  /* fractudqda2 */
    case 763:  /* fractdqda2 */
    case 762:  /* fractusada2 */
    case 761:  /* fractsada2 */
    case 760:  /* fractusqda2 */
    case 759:  /* fractsqda2 */
    case 758:  /* fractuhada2 */
    case 757:  /* fracthada2 */
    case 756:  /* fractuhqda2 */
    case 755:  /* fracthqda2 */
    case 754:  /* fractuqqda2 */
    case 753:  /* fractqqda2 */
    case 752:  /* fractdiudq2 */
    case 751:  /* fractsiudq2 */
    case 750:  /* fracthiudq2 */
    case 749:  /* fractqiudq2 */
    case 748:  /* fractutaudq2 */
    case 747:  /* fracttaudq2 */
    case 746:  /* fractudaudq2 */
    case 745:  /* fractdaudq2 */
    case 744:  /* fractdqudq2 */
    case 743:  /* fractusaudq2 */
    case 742:  /* fractsaudq2 */
    case 741:  /* fractusqudq2 */
    case 740:  /* fractsqudq2 */
    case 739:  /* fractuhaudq2 */
    case 738:  /* fracthaudq2 */
    case 737:  /* fractuhqudq2 */
    case 736:  /* fracthqudq2 */
    case 735:  /* fractuqqudq2 */
    case 734:  /* fractqqudq2 */
    case 733:  /* fractdidq2 */
    case 732:  /* fractsidq2 */
    case 731:  /* fracthidq2 */
    case 730:  /* fractqidq2 */
    case 729:  /* fractutadq2 */
    case 728:  /* fracttadq2 */
    case 727:  /* fractudadq2 */
    case 726:  /* fractdadq2 */
    case 725:  /* fractudqdq2 */
    case 724:  /* fractusadq2 */
    case 723:  /* fractsadq2 */
    case 722:  /* fractusqdq2 */
    case 721:  /* fractsqdq2 */
    case 720:  /* fractuhadq2 */
    case 719:  /* fracthadq2 */
    case 718:  /* fractuhqdq2 */
    case 717:  /* fracthqdq2 */
    case 716:  /* fractuqqdq2 */
    case 715:  /* fractqqdq2 */
    case 714:  /* fractdiusa2 */
    case 713:  /* fractsiusa2 */
    case 712:  /* fracthiusa2 */
    case 711:  /* fractqiusa2 */
    case 710:  /* fractutausa2 */
    case 709:  /* fracttausa2 */
    case 708:  /* fractudausa2 */
    case 707:  /* fractdausa2 */
    case 706:  /* fractudqusa2 */
    case 705:  /* fractdqusa2 */
    case 704:  /* fractsausa2 */
    case 703:  /* fractusqusa2 */
    case 702:  /* fractsqusa2 */
    case 701:  /* fractuhausa2 */
    case 700:  /* fracthausa2 */
    case 699:  /* fractuhqusa2 */
    case 698:  /* fracthqusa2 */
    case 697:  /* fractuqqusa2 */
    case 696:  /* fractqqusa2 */
    case 695:  /* fractdisa2 */
    case 694:  /* fractsisa2 */
    case 693:  /* fracthisa2 */
    case 692:  /* fractqisa2 */
    case 691:  /* fractutasa2 */
    case 690:  /* fracttasa2 */
    case 689:  /* fractudasa2 */
    case 688:  /* fractdasa2 */
    case 687:  /* fractudqsa2 */
    case 686:  /* fractdqsa2 */
    case 685:  /* fractusasa2 */
    case 684:  /* fractusqsa2 */
    case 683:  /* fractsqsa2 */
    case 682:  /* fractuhasa2 */
    case 681:  /* fracthasa2 */
    case 680:  /* fractuhqsa2 */
    case 679:  /* fracthqsa2 */
    case 678:  /* fractuqqsa2 */
    case 677:  /* fractqqsa2 */
    case 676:  /* fractdiusq2 */
    case 675:  /* fractsiusq2 */
    case 674:  /* fracthiusq2 */
    case 673:  /* fractqiusq2 */
    case 672:  /* fractutausq2 */
    case 671:  /* fracttausq2 */
    case 670:  /* fractudausq2 */
    case 669:  /* fractdausq2 */
    case 668:  /* fractudqusq2 */
    case 667:  /* fractdqusq2 */
    case 666:  /* fractusausq2 */
    case 665:  /* fractsausq2 */
    case 664:  /* fractsqusq2 */
    case 663:  /* fractuhausq2 */
    case 662:  /* fracthausq2 */
    case 661:  /* fractuhqusq2 */
    case 660:  /* fracthqusq2 */
    case 659:  /* fractuqqusq2 */
    case 658:  /* fractqqusq2 */
    case 657:  /* fractdisq2 */
    case 656:  /* fractsisq2 */
    case 655:  /* fracthisq2 */
    case 654:  /* fractqisq2 */
    case 653:  /* fractutasq2 */
    case 652:  /* fracttasq2 */
    case 651:  /* fractudasq2 */
    case 650:  /* fractdasq2 */
    case 649:  /* fractudqsq2 */
    case 648:  /* fractdqsq2 */
    case 647:  /* fractusasq2 */
    case 646:  /* fractsasq2 */
    case 645:  /* fractusqsq2 */
    case 644:  /* fractuhasq2 */
    case 643:  /* fracthasq2 */
    case 642:  /* fractuhqsq2 */
    case 641:  /* fracthqsq2 */
    case 640:  /* fractuqqsq2 */
    case 639:  /* fractqqsq2 */
    case 638:  /* fractdiuha2 */
    case 637:  /* fractsiuha2 */
    case 636:  /* fracthiuha2 */
    case 635:  /* fractqiuha2 */
    case 634:  /* fractutauha2 */
    case 633:  /* fracttauha2 */
    case 632:  /* fractudauha2 */
    case 631:  /* fractdauha2 */
    case 630:  /* fractudquha2 */
    case 629:  /* fractdquha2 */
    case 628:  /* fractusauha2 */
    case 627:  /* fractsauha2 */
    case 626:  /* fractusquha2 */
    case 625:  /* fractsquha2 */
    case 624:  /* fracthauha2 */
    case 623:  /* fractuhquha2 */
    case 622:  /* fracthquha2 */
    case 621:  /* fractuqquha2 */
    case 620:  /* fractqquha2 */
    case 619:  /* fractdiha2 */
    case 618:  /* fractsiha2 */
    case 617:  /* fracthiha2 */
    case 616:  /* fractqiha2 */
    case 615:  /* fractutaha2 */
    case 614:  /* fracttaha2 */
    case 613:  /* fractudaha2 */
    case 612:  /* fractdaha2 */
    case 611:  /* fractudqha2 */
    case 610:  /* fractdqha2 */
    case 609:  /* fractusaha2 */
    case 608:  /* fractsaha2 */
    case 607:  /* fractusqha2 */
    case 606:  /* fractsqha2 */
    case 605:  /* fractuhaha2 */
    case 604:  /* fractuhqha2 */
    case 603:  /* fracthqha2 */
    case 602:  /* fractuqqha2 */
    case 601:  /* fractqqha2 */
    case 600:  /* fractdiuhq2 */
    case 599:  /* fractsiuhq2 */
    case 598:  /* fracthiuhq2 */
    case 597:  /* fractqiuhq2 */
    case 596:  /* fractutauhq2 */
    case 595:  /* fracttauhq2 */
    case 594:  /* fractudauhq2 */
    case 593:  /* fractdauhq2 */
    case 592:  /* fractudquhq2 */
    case 591:  /* fractdquhq2 */
    case 590:  /* fractusauhq2 */
    case 589:  /* fractsauhq2 */
    case 588:  /* fractusquhq2 */
    case 587:  /* fractsquhq2 */
    case 586:  /* fractuhauhq2 */
    case 585:  /* fracthauhq2 */
    case 584:  /* fracthquhq2 */
    case 583:  /* fractuqquhq2 */
    case 582:  /* fractqquhq2 */
    case 581:  /* fractdihq2 */
    case 580:  /* fractsihq2 */
    case 579:  /* fracthihq2 */
    case 578:  /* fractqihq2 */
    case 577:  /* fractutahq2 */
    case 576:  /* fracttahq2 */
    case 575:  /* fractudahq2 */
    case 574:  /* fractdahq2 */
    case 573:  /* fractudqhq2 */
    case 572:  /* fractdqhq2 */
    case 571:  /* fractusahq2 */
    case 570:  /* fractsahq2 */
    case 569:  /* fractusqhq2 */
    case 568:  /* fractsqhq2 */
    case 567:  /* fractuhahq2 */
    case 566:  /* fracthahq2 */
    case 565:  /* fractuhqhq2 */
    case 564:  /* fractuqqhq2 */
    case 563:  /* fractqqhq2 */
    case 562:  /* fractdiuqq2 */
    case 561:  /* fractsiuqq2 */
    case 560:  /* fracthiuqq2 */
    case 559:  /* fractqiuqq2 */
    case 558:  /* fractutauqq2 */
    case 557:  /* fracttauqq2 */
    case 556:  /* fractudauqq2 */
    case 555:  /* fractdauqq2 */
    case 554:  /* fractudquqq2 */
    case 553:  /* fractdquqq2 */
    case 552:  /* fractusauqq2 */
    case 551:  /* fractsauqq2 */
    case 550:  /* fractusquqq2 */
    case 549:  /* fractsquqq2 */
    case 548:  /* fractuhauqq2 */
    case 547:  /* fracthauqq2 */
    case 546:  /* fractuhquqq2 */
    case 545:  /* fracthquqq2 */
    case 544:  /* fractqquqq2 */
    case 543:  /* fractdiqq2 */
    case 542:  /* fractsiqq2 */
    case 541:  /* fracthiqq2 */
    case 540:  /* fractqiqq2 */
    case 539:  /* fractutaqq2 */
    case 538:  /* fracttaqq2 */
    case 537:  /* fractudaqq2 */
    case 536:  /* fractdaqq2 */
    case 535:  /* fractudqqq2 */
    case 534:  /* fractdqqq2 */
    case 533:  /* fractusaqq2 */
    case 532:  /* fractsaqq2 */
    case 531:  /* fractusqqq2 */
    case 530:  /* fractsqqq2 */
    case 529:  /* fractuhaqq2 */
    case 528:  /* fracthaqq2 */
    case 527:  /* fractuhqqq2 */
    case 526:  /* fracthqqq2 */
    case 525:  /* fractuqqqq2 */
    case 379:  /* zero_extendsidi2 */
    case 378:  /* zero_extendhidi2 */
    case 377:  /* zero_extendqidi2 */
    case 376:  /* zero_extendpsisi2 */
    case 375:  /* zero_extendhisi2 */
    case 373:  /* zero_extendhipsi2 */
    case 372:  /* zero_extendqisi2 */
    case 371:  /* zero_extendqipsi2 */
    case 370:  /* zero_extendqihi2 */
    case 369:  /* extendpsisi2 */
    case 368:  /* extendhisi2 */
    case 367:  /* extendhipsi2 */
    case 366:  /* extendqisi2 */
    case 365:  /* extendqipsi2 */
    case 364:  /* extendqihi2 */
    case 363:  /* one_cmplsi2 */
    case 362:  /* one_cmplpsi2 */
    case 361:  /* one_cmplhi2 */
    case 360:  /* one_cmplqi2 */
    case 359:  /* negsf2 */
    case 358:  /* negsi2 */
    case 357:  /* negpsi2 */
    case 356:  /* neghi2 */
    case 354:  /* negqi2 */
    case 353:  /* abssf2 */
    case 352:  /* absqi2 */
    case 268:  /* *rotlsi2.31 */
    case 267:  /* *rotlsi2.1 */
    case 266:  /* *rotlpsi2.23 */
    case 265:  /* *rotlpsi2.1 */
    case 264:  /* *rotlhi2.15 */
    case 263:  /* *rotlhi2.1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 237:  /* *umulhiqipsi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 248:  /* udivmodsi4 */
    case 246:  /* divmodsi4 */
    case 244:  /* udivmodpsi4 */
    case 242:  /* divmodpsi4 */
    case 234:  /* udivmodhi4 */
    case 232:  /* divmodhi4 */
    case 230:  /* udivmodqi4 */
    case 228:  /* divmodqi4 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 218:  /* *uumulhihisi3 */
    case 217:  /* *sumulhihisi3 */
    case 216:  /* *usmulhihisi3 */
    case 215:  /* *ssmulhihisi3 */
    case 214:  /* *uumulqihisi3 */
    case 213:  /* *sumulqihisi3 */
    case 212:  /* *usmulqihisi3 */
    case 211:  /* *ssmulqihisi3 */
    case 210:  /* *uumulhiqisi3 */
    case 209:  /* *sumulhiqisi3 */
    case 208:  /* *usmulhiqisi3 */
    case 207:  /* *ssmulhiqisi3 */
    case 206:  /* *uumulqiqisi3 */
    case 205:  /* *sumulqiqisi3 */
    case 204:  /* *usmulqiqisi3 */
    case 203:  /* *ssmulqiqisi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      break;

    case 202:  /* *mulohisi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 238:  /* *mulsqipsi3 */
    case 201:  /* *mulshisi3 */
    case 200:  /* *mulsqisi3 */
    case 199:  /* *muluhisi3 */
    case 198:  /* *muluqisi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 239:  /* *mulpsi3 */
    case 197:  /* *mulsi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 194:  /* muloqihi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 190:  /* *ashifthi3.signx.const7 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 182:  /* *sumsubqihi4.uconst */
    case 180:  /* *msubqihi4.sconst.ashift */
    case 179:  /* *umsubqihi4.uconst.ashift */
    case 178:  /* *umsubqihi4.uconst */
    case 177:  /* *msubqihi4.sconst */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 181:  /* *sumaddqihi4.uconst */
    case 176:  /* *umaddqihi4.uconst */
    case 175:  /* *maddqihi4.sconst */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 514:  /* *iorhi3.ashift8-ext.reg */
    case 513:  /* *iorhi3.ashift8-ext.reg */
    case 174:  /* *umaddqihi4.2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 173:  /* *sumsubqihi4 */
    case 172:  /* *usmsubqihi4 */
    case 169:  /* *umsubqihi4 */
    case 168:  /* *msubqihi4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 171:  /* *sumsubqihi4 */
    case 170:  /* *usmsubqihi4 */
    case 167:  /* *umaddqihi4 */
    case 166:  /* *maddqihi4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 165:  /* *msubqi4.const */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 164:  /* *maddqi4.const */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 163:  /* *msubqi4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 162:  /* *maddqi4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 161:  /* *oumulqihi3 */
    case 160:  /* *osmulqihi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 425:  /* call_value_insn */
    case 191:  /* *ashifthi3.zerox.const */
    case 189:  /* *ashifthi3.signx.const */
    case 187:  /* *mulsqihi3.oconst */
    case 186:  /* *mulsqihi3.uconst */
    case 185:  /* *muluqihi3.sconst */
    case 184:  /* *muluqihi3.uconst */
    case 183:  /* *mulsqihi3.sconst */
    case 152:  /* *addhi3.lt0 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 149:  /* umulqi3_highpart */
    case 148:  /* smulqi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      break;

    case 374:  /* n_extendhipsi2 */
    case 351:  /* *lshrusa3_const */
    case 350:  /* *lshrsa3_const */
    case 349:  /* *lshrusq3_const */
    case 348:  /* *lshrsq3_const */
    case 347:  /* *lshrsi3_const */
    case 346:  /* *lshruha3_const */
    case 345:  /* *lshrha3_const */
    case 344:  /* *lshruhq3_const */
    case 343:  /* *lshrhq3_const */
    case 342:  /* *lshrhi3_const */
    case 336:  /* lshrpsi3 */
    case 327:  /* *ashrusa3_const */
    case 326:  /* *ashrsa3_const */
    case 325:  /* *ashrusq3_const */
    case 324:  /* *ashrsq3_const */
    case 323:  /* *ashrsi3_const */
    case 322:  /* *ashruha3_const */
    case 321:  /* *ashrha3_const */
    case 320:  /* *ashruhq3_const */
    case 319:  /* *ashrhq3_const */
    case 318:  /* *ashrhi3_const */
    case 312:  /* ashrpsi3 */
    case 303:  /* *ashlpsi3 */
    case 302:  /* *ashlusa3_const */
    case 301:  /* *ashlsa3_const */
    case 300:  /* *ashlusq3_const */
    case 299:  /* *ashlsq3_const */
    case 298:  /* *ashlsi3_const */
    case 297:  /* *ashluha3_const */
    case 296:  /* *ashlha3_const */
    case 295:  /* *ashluhq3_const */
    case 294:  /* *ashlhq3_const */
    case 293:  /* *ashlhi3_const */
    case 274:  /* *rotbsi */
    case 273:  /* *rotbpsi */
    case 272:  /* *rotbhi */
    case 271:  /* *rotwsi */
    case 270:  /* *rotwpsi */
    case 269:  /* *rotwhi */
    case 261:  /* xorsi3 */
    case 260:  /* xorpsi3 */
    case 259:  /* xorhi3 */
    case 257:  /* iorsi3 */
    case 256:  /* iorpsi3 */
    case 255:  /* iorhi3 */
    case 253:  /* andsi3 */
    case 252:  /* andpsi3 */
    case 251:  /* andhi3 */
    case 143:  /* subusa3 */
    case 142:  /* subsa3 */
    case 141:  /* subusq3 */
    case 140:  /* subsq3 */
    case 139:  /* subsi3 */
    case 136:  /* subuha3 */
    case 135:  /* subha3 */
    case 134:  /* subuhq3 */
    case 133:  /* subhq3 */
    case 132:  /* subhi3 */
    case 124:  /* addpsi3 */
    case 118:  /* addusa3 */
    case 117:  /* addsa3 */
    case 116:  /* addusq3 */
    case 115:  /* addsq3 */
    case 114:  /* addsi3 */
    case 113:  /* adduha3_clobber */
    case 112:  /* addha3_clobber */
    case 111:  /* adduhq3_clobber */
    case 110:  /* addhq3_clobber */
    case 109:  /* addhi3_clobber */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 103:  /* *addhi3_sp */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 1));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 515:  /* *iorhi3.ashift8-reg.zerox */
    case 484:  /* *movbitqi.7 */
    case 236:  /* *umulqihipsi3 */
    case 159:  /* *sumulqihi3 */
    case 158:  /* usmulqihi3 */
    case 157:  /* umulqihi3 */
    case 156:  /* mulqihi3 */
    case 102:  /* *udiff_widenqihi3 */
    case 101:  /* *usum_widenqihi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 150:  /* *subqi3.ashiftrt7 */
    case 145:  /* *subsi3_zero_extend.hi */
    case 144:  /* *subsi3_zero_extend */
    case 138:  /* *subhi3.sign_extend2 */
    case 137:  /* *subhi3_zero_extend1 */
    case 128:  /* *subpsi3_sign_extend.hi */
    case 127:  /* *subpsi3_zero_extend.hi */
    case 126:  /* *subpsi3_zero_extend.qi */
    case 98:  /* *addhi3_zero_extend1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 504:  /* *iorsiqi.byte0 */
    case 503:  /* *xorsiqi.byte0 */
    case 502:  /* *iorpsiqi.byte0 */
    case 501:  /* *xorpsiqi.byte0 */
    case 500:  /* *iorhiqi.byte0 */
    case 499:  /* *xorhiqi.byte0 */
    case 193:  /* muluqihi3 */
    case 192:  /* mulsqihi3 */
    case 154:  /* *addsi3.lt0 */
    case 153:  /* *addpsi3.lt0 */
    case 151:  /* *addqi3.lt0 */
    case 123:  /* *addsi3_zero_extend.hi */
    case 122:  /* *addsi3_zero_extend */
    case 121:  /* *addpsi3_sign_extend.hi */
    case 120:  /* *addpsi3_zero_extend.hi */
    case 119:  /* *addpsi3_zero_extend.qi */
    case 100:  /* *addhi3_zero_extend.const */
    case 99:  /* *addhi3.sign_extend1 */
    case 97:  /* *addhi3_zero_extend */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 1316:  /* muluqq3_enh */
    case 1315:  /* mulqq3_enh */
    case 1304:  /* ussubusq3 */
    case 1303:  /* usaddusq3 */
    case 1302:  /* ussubusa3 */
    case 1301:  /* usaddusa3 */
    case 1300:  /* ussubuha3 */
    case 1299:  /* usadduha3 */
    case 1298:  /* ussubuhq3 */
    case 1297:  /* usadduhq3 */
    case 1296:  /* ussubuqq3 */
    case 1295:  /* usadduqq3 */
    case 1294:  /* sssubsq3 */
    case 1293:  /* ssaddsq3 */
    case 1292:  /* sssubsa3 */
    case 1291:  /* ssaddsa3 */
    case 1290:  /* sssubha3 */
    case 1289:  /* ssaddha3 */
    case 1288:  /* sssubhq3 */
    case 1287:  /* ssaddhq3 */
    case 1286:  /* sssubqq3 */
    case 1285:  /* ssaddqq3 */
    case 341:  /* lshrusa3 */
    case 340:  /* lshrsa3 */
    case 339:  /* lshrusq3 */
    case 338:  /* lshrsq3 */
    case 337:  /* lshrsi3 */
    case 335:  /* lshruha3 */
    case 334:  /* lshrha3 */
    case 333:  /* lshruhq3 */
    case 332:  /* lshrhq3 */
    case 331:  /* lshrhi3 */
    case 330:  /* *lshruqq3 */
    case 329:  /* *lshrqq3 */
    case 328:  /* *lshrqi3 */
    case 317:  /* ashrusa3 */
    case 316:  /* ashrsa3 */
    case 315:  /* ashrusq3 */
    case 314:  /* ashrsq3 */
    case 313:  /* ashrsi3 */
    case 311:  /* ashruha3 */
    case 310:  /* ashrha3 */
    case 309:  /* ashruhq3 */
    case 308:  /* ashrhq3 */
    case 307:  /* ashrhi3 */
    case 306:  /* ashruqq3 */
    case 305:  /* ashrqq3 */
    case 304:  /* ashrqi3 */
    case 292:  /* ashlusa3 */
    case 291:  /* ashlsa3 */
    case 290:  /* ashlusq3 */
    case 289:  /* ashlsq3 */
    case 288:  /* ashlsi3 */
    case 282:  /* ashluha3 */
    case 281:  /* ashlha3 */
    case 280:  /* ashluhq3 */
    case 279:  /* ashlhq3 */
    case 278:  /* ashlhi3 */
    case 277:  /* *ashluqq3 */
    case 276:  /* *ashlqq3 */
    case 275:  /* *ashlqi3 */
    case 262:  /* *rotlqi3 */
    case 258:  /* xorqi3 */
    case 254:  /* iorqi3 */
    case 250:  /* andqi3 */
    case 195:  /* *mulhi3_enh */
    case 146:  /* *mulqi3_enh */
    case 131:  /* subuqq3 */
    case 130:  /* subqq3 */
    case 129:  /* subqi3 */
    case 125:  /* subpsi3 */
    case 108:  /* *adduha3 */
    case 107:  /* *addha3 */
    case 106:  /* *adduhq3 */
    case 105:  /* *addhq3 */
    case 104:  /* *addhi3 */
    case 96:  /* adduqq3 */
    case 95:  /* addqq3 */
    case 94:  /* addqi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 93:  /* *strlenhi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 92:  /* *clrmemhi */
    case 91:  /* *clrmemqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 4), 0));
      break;

    case 90:  /* movmemx_hi */
    case 89:  /* movmemx_qi */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 8), 0), 0));
      break;

    case 88:  /* movmem_hi */
    case 87:  /* movmem_qi */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 6), 0));
      break;

    case 1349:  /* roundusq3_const */
    case 1348:  /* roundusa3_const */
    case 1347:  /* rounduha3_const */
    case 1346:  /* rounduhq3_const */
    case 1345:  /* rounduqq3_const */
    case 1344:  /* roundsq3_const */
    case 1343:  /* roundsa3_const */
    case 1342:  /* roundha3_const */
    case 1341:  /* roundhq3_const */
    case 1340:  /* roundqq3_const */
    case 479:  /* fmulsu_insn */
    case 477:  /* fmuls_insn */
    case 475:  /* fmul_insn */
    case 470:  /* copysignsf3 */
    case 62:  /* movhi_sp_r */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 86:  /* *reload_insf */
    case 79:  /* *reload_insi */
    case 78:  /* *reload_insi */
    case 77:  /* *reload_insi */
    case 76:  /* *reload_insi */
    case 75:  /* *reload_insi */
    case 73:  /* *reload_inpsi */
    case 67:  /* *reload_inuha */
    case 66:  /* *reload_inha */
    case 65:  /* *reload_inuhq */
    case 64:  /* *reload_inhq */
    case 63:  /* *reload_inhi */
    case 61:  /* *reload_inuqq */
    case 60:  /* *reload_inqq */
    case 59:  /* *reload_inqi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 85:  /* *movsf */
    case 84:  /* *movusa */
    case 83:  /* *movsa */
    case 82:  /* *movusq */
    case 81:  /* *movsq */
    case 80:  /* *movsi */
    case 74:  /* *movpsi */
    case 72:  /* *movuha */
    case 71:  /* *movha */
    case 70:  /* *movuhq */
    case 69:  /* *movhq */
    case 68:  /* *movhi */
    case 58:  /* movuqq_insn */
    case 57:  /* movqq_insn */
    case 56:  /* movqi_insn */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 1458:  /* umulsidi3_insn */
    case 1457:  /* mulsidi3_insn */
    case 1456:  /* rotluta3_insn */
    case 1455:  /* lshruta3_insn */
    case 1454:  /* ashruta3_insn */
    case 1453:  /* ashluta3_insn */
    case 1452:  /* rotlta3_insn */
    case 1451:  /* lshrta3_insn */
    case 1450:  /* ashrta3_insn */
    case 1449:  /* ashlta3_insn */
    case 1448:  /* rotluda3_insn */
    case 1447:  /* lshruda3_insn */
    case 1446:  /* ashruda3_insn */
    case 1445:  /* ashluda3_insn */
    case 1444:  /* rotlda3_insn */
    case 1443:  /* lshrda3_insn */
    case 1442:  /* ashrda3_insn */
    case 1441:  /* ashlda3_insn */
    case 1440:  /* rotludq3_insn */
    case 1439:  /* lshrudq3_insn */
    case 1438:  /* ashrudq3_insn */
    case 1437:  /* ashludq3_insn */
    case 1436:  /* rotldq3_insn */
    case 1435:  /* lshrdq3_insn */
    case 1434:  /* ashrdq3_insn */
    case 1433:  /* ashldq3_insn */
    case 1432:  /* rotldi3_insn */
    case 1431:  /* lshrdi3_insn */
    case 1430:  /* ashrdi3_insn */
    case 1429:  /* ashldi3_insn */
    case 1421:  /* compare_const8_di2 */
    case 1420:  /* compare_uta2 */
    case 1419:  /* compare_ta2 */
    case 1418:  /* compare_uda2 */
    case 1417:  /* compare_da2 */
    case 1416:  /* compare_udq2 */
    case 1415:  /* compare_dq2 */
    case 1414:  /* compare_di2 */
    case 1413:  /* negdi2_insn */
    case 1406:  /* ussubuta3_insn */
    case 1405:  /* usadduta3_insn */
    case 1404:  /* ussubuda3_insn */
    case 1403:  /* usadduda3_insn */
    case 1402:  /* ussubudq3_insn */
    case 1401:  /* usaddudq3_insn */
    case 1394:  /* sssubta3_insn */
    case 1393:  /* ssaddta3_insn */
    case 1392:  /* sssubda3_insn */
    case 1391:  /* ssaddda3_insn */
    case 1390:  /* sssubdq3_insn */
    case 1389:  /* ssadddq3_insn */
    case 1381:  /* subuta3_insn */
    case 1380:  /* subta3_insn */
    case 1379:  /* subuda3_insn */
    case 1378:  /* subda3_insn */
    case 1377:  /* subudq3_insn */
    case 1376:  /* subdq3_insn */
    case 1375:  /* subdi3_insn */
    case 1367:  /* adddi3_const8_insn */
    case 1366:  /* adduta3_insn */
    case 1365:  /* addta3_insn */
    case 1364:  /* adduda3_insn */
    case 1363:  /* addda3_insn */
    case 1362:  /* addudq3_insn */
    case 1361:  /* adddq3_insn */
    case 1360:  /* adddi3_insn */
    case 1359:  /* *roundusa3.libgcc */
    case 1358:  /* *roundsa3.libgcc */
    case 1357:  /* *roundusq3.libgcc */
    case 1356:  /* *roundsq3.libgcc */
    case 1355:  /* *rounduha3.libgcc */
    case 1354:  /* *roundha3.libgcc */
    case 1353:  /* *rounduhq3.libgcc */
    case 1352:  /* *roundhq3.libgcc */
    case 1351:  /* *rounduqq3.libgcc */
    case 1350:  /* *roundqq3.libgcc */
    case 1339:  /* *divusa3.call */
    case 1338:  /* *udivusa3.call */
    case 1337:  /* *divsa3.call */
    case 1336:  /* *udivsa3.call */
    case 1335:  /* *divuha3.call */
    case 1334:  /* *udivuha3.call */
    case 1333:  /* *divha3.call */
    case 1332:  /* *udivha3.call */
    case 1331:  /* *divuhq3.call */
    case 1330:  /* *udivuhq3.call */
    case 1329:  /* *divhq3.call */
    case 1328:  /* *udivhq3.call */
    case 1327:  /* *divuqq3.call */
    case 1326:  /* *udivuqq3.call */
    case 1325:  /* *divqq3.call */
    case 1324:  /* *udivqq3.call */
    case 1323:  /* *mulusa3.call */
    case 1322:  /* *mulsa3.call */
    case 1321:  /* *muluha3.call */
    case 1320:  /* *mulha3.call */
    case 1319:  /* *muluhq3.call */
    case 1318:  /* *mulhq3.call */
    case 1317:  /* *mulqq3.call */
    case 1314:  /* *ssnegsq2 */
    case 1313:  /* *ssabssq2 */
    case 1312:  /* *ssnegsa2 */
    case 1311:  /* *ssabssa2 */
    case 1310:  /* *ssnegha2 */
    case 1309:  /* *ssabsha2 */
    case 1308:  /* *ssneghq2 */
    case 1307:  /* *ssabshq2 */
    case 480:  /* *fmulsu.call */
    case 478:  /* *fmuls.call */
    case 476:  /* *fmul.call */
    case 471:  /* *bswapsi2.libgcc */
    case 469:  /* *ffssihi2.libgcc */
    case 468:  /* *ffshi2.libgcc */
    case 467:  /* *ctzsihi2.libgcc */
    case 466:  /* *ctzhi2.libgcc */
    case 465:  /* *clzsihi2.libgcc */
    case 464:  /* *clzhi2.libgcc */
    case 463:  /* *popcountqihi2.libgcc */
    case 462:  /* *popcountqi2.libgcc */
    case 461:  /* *popcountsi2.libgcc */
    case 460:  /* *popcounthi2.libgcc */
    case 459:  /* *paritysihi2.libgcc */
    case 458:  /* *parityqihi2.libgcc */
    case 457:  /* *parityhi2.libgcc */
    case 448:  /* return_from_naked_epilogue */
    case 447:  /* return_from_interrupt_epilogue */
    case 446:  /* return_from_epilogue */
    case 445:  /* return */
    case 432:  /* sez */
    case 426:  /* nop */
    case 249:  /* *udivmodsi4_call */
    case 247:  /* *divmodsi4_call */
    case 245:  /* *udivmodpsi4_call */
    case 243:  /* *divmodpsi4_call */
    case 241:  /* *mulpsi3.libgcc */
    case 240:  /* *mulsqipsi3.libgcc */
    case 235:  /* *udivmodhi4_call */
    case 233:  /* *divmodhi4_call */
    case 231:  /* *udivmodqi4_call */
    case 229:  /* *divmodqi4_call */
    case 227:  /* *mulohisi3_call */
    case 226:  /* *muluhisi3_call */
    case 225:  /* *mulshisi3_call */
    case 224:  /* *usmulhisi3_call */
    case 223:  /* *umulhi3_highpart_call */
    case 222:  /* *smulhi3_highpart_call */
    case 221:  /* *umulhisi3_call */
    case 220:  /* *mulhisi3_call */
    case 219:  /* *mulsi3_call */
    case 196:  /* *mulhi3_call */
    case 155:  /* *umulqihi3.call */
    case 147:  /* *mulqi3_call */
    case 55:  /* xload_psi_libgcc */
    case 54:  /* xload_sf_libgcc */
    case 53:  /* xload_usa_libgcc */
    case 52:  /* xload_sa_libgcc */
    case 51:  /* xload_usq_libgcc */
    case 50:  /* xload_sq_libgcc */
    case 49:  /* xload_si_libgcc */
    case 48:  /* xload_uha_libgcc */
    case 47:  /* xload_ha_libgcc */
    case 46:  /* xload_uhq_libgcc */
    case 45:  /* xload_hq_libgcc */
    case 44:  /* xload_hi_libgcc */
    case 43:  /* xload_uqq_libgcc */
    case 42:  /* xload_qq_libgcc */
    case 41:  /* xload_qi_libgcc */
      break;

    case 355:  /* *negqihi2 */
    case 188:  /* *ashiftqihi2.signx.1 */
    case 40:  /* xloaduqq_8 */
    case 39:  /* xloadqq_8 */
    case 38:  /* xloadqi_8 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 37:  /* xloadpsi_A */
    case 36:  /* xloadsf_A */
    case 35:  /* xloadusa_A */
    case 34:  /* xloadsa_A */
    case 33:  /* xloadusq_A */
    case 32:  /* xloadsq_A */
    case 31:  /* xloadsi_A */
    case 30:  /* xloaduha_A */
    case 29:  /* xloadha_A */
    case 28:  /* xloaduhq_A */
    case 27:  /* xloadhq_A */
    case 26:  /* xloadhi_A */
    case 25:  /* xloaduqq_A */
    case 24:  /* xloadqq_A */
    case 23:  /* xloadqi_A */
    case 22:  /* xload8uqq_A */
    case 21:  /* xload8qq_A */
    case 20:  /* xload8qi_A */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 427:  /* *indirect_jump */
    case 19:  /* load_psi_libgcc */
    case 18:  /* load_sf_libgcc */
    case 17:  /* load_usa_libgcc */
    case 16:  /* load_sa_libgcc */
    case 15:  /* load_usq_libgcc */
    case 14:  /* load_sq_libgcc */
    case 13:  /* load_si_libgcc */
    case 12:  /* load_uha_libgcc */
    case 11:  /* load_ha_libgcc */
    case 10:  /* load_uhq_libgcc */
    case 9:  /* load_hq_libgcc */
    case 8:  /* load_hi_libgcc */
    case 7:  /* load_uqq_libgcc */
    case 6:  /* load_qq_libgcc */
    case 5:  /* load_qi_libgcc */
    case 4:  /* pushhi1_insn */
    case 3:  /* pushuqq1 */
    case 2:  /* pushqq1 */
    case 1:  /* pushqi1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    }
}
